<?php
$MEMCACHE_SERVER['host'] = 'localhost';
$MEMCACHE_SERVER['port'] = '12112'; 

function sendMemcacheCommand($command){
	Global $MEMCACHE_SERVER;
	$s = @fsockopen($MEMCACHE_SERVER['host'],$MEMCACHE_SERVER['port']);
	if (!$s){
		die("Cant connect to:".$MEMCACHE_SERVER['host'].':'.$MEMCACHE_SERVER['host']);
	}

	fwrite($s, $command."\r\n");

	$buf='';
	while ((!feof($s))) {
		$buf .= fgets($s, 256);
		if (strpos($buf,"END\r\n")!==false){ // stat says end
		    break;
		}
		if (strpos($buf,"DELETED\r\n")!==false || strpos($buf,"NOT_FOUND\r\n")!==false){ // delete says these
		    break;
		}
		if (strpos($buf,"OK\r\n")!==false){ // flush_all says ok
		    break;
		}

	}
	fclose($s);
	return parseMemcacheResults($buf);
}

function sendMemcacheData($command,$data){
	Global $MEMCACHE_SERVER;
	$s = @fsockopen($MEMCACHE_SERVER['host'],$MEMCACHE_SERVER['port']);
	if (!$s){
		die("Cant connect to:".$MEMCACHE_SERVER['host'].':'.$MEMCACHE_SERVER['port']);
	}

	fwrite($s, $command."\r\n");
	fwrite($s, $data."\r\n");

	$buf='';
	while ((!feof($s))) {
		$buf .= fgets($s, 256);
		if (strpos($buf,"STORED\r\n")!==false){ 
		    break;
		}
		if (strpos($buf,"NOT_STORED\r\n")!==false){ 
		    break;
		}

	}
	fclose($s);
	return parseMemcacheResults($buf);
}

function parseMemcacheResults($str){
    
	$res = array();
	$lines = explode("\r\n",$str);
	$cnt = count($lines);
	for($i=0; $i< $cnt; $i++){
	    $line = $lines[$i];
		$l = explode(' ',$line,3);
		if (count($l)==3){
			$res[$l[0]][$l[1]]=$l[2];
			if ($l[0]=='VALUE'){ // next line is the value
			    $res[$l[0]][$l[1]] = array();
			    list ($flag,$size)=explode(' ',$l[2]);
			    $res[$l[0]][$l[1]]['stat']=array('flag'=>$flag,'size'=>$size);
			    $res[$l[0]][$l[1]]['value']=$lines[++$i];
			}
		}elseif($line=='DELETED' || $line=='NOT_FOUND' || $line=='STORED' || $line=='NOT_STORED'){
		    return $line;
		}
	}
	return $res;

}
?>
